datablock staticShapeData(SSFlatBedData)
{
	shapefile = "Add-Ons/Shape_Keter/detflatbed.dts";
};

datablock staticShapeData(SSFlatBedCOLData)
{
	shapefile = "Add-Ons/Shape_Keter/COLflatbed.dts";
};

//function addExtraResource(%name)
//{
//    if (MissionGroup.addedResource[%name]) return;
//    MissionGroup.addedResource[%name] = "1";
//    $EnvGuiServer::Resource[$EnvGuiServer::ResourceCount] = %name;
//    $EnvGuiServer::ResourceCount++;
//    setManifestDirty();
//}

//addExtraResource("Add-Ons/Shape_Keter/COLflatbed.dts");

package autoloadflatbedpackage
{
	function onMissionLoaded()
	{
		Parent::onMissionLoaded();
		initFlatBed();
		stepLoop();
	}
};
activatepackage(autoloadflatbedpackage);

function initFlatBed()
{
	if(isObject(SSFlatBedDet))
		SSFlatBedDet.delete();
	if(isObject(SSFlatBedCOL))
		SSFlatBedCOL.delete();
	if(isObject(TriggerFlatBed))
		TriggerFlatBed.delete();

	new StaticShape(SSFlatBedDet)
	{
		position = "0 0 1.45";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "SSFlatBedData";
		canSetIFLS = false;
	};
	SSFlatBedDet.playthread(3,roll);
	//SSFlatBedDet.schedule(10000,"stopthread",3);
	new StaticShape(SSFlatBedCOL)
	{
		position = "0 0 1.45";
		rotation = "1 0 0 0";
		scale = "0.5 0.5 0.5";
		dataBlock = "SSFlatBedCOLData";
		canSetIFLS = false;
	};
	$FBStep = 0;

	new Trigger(TriggerFlatBed)
	{
		position = "0 0 1";
		rotation = "1 0 0 0";
		scale = "4 8 2";
		dataBlock = "FlatBedTrigger";
		polyhedron = "-0.5000000 -0.5000000 -0.5000000 1.0000000 0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
	};
}

function stepFlatBed()
{
	%pos = vectorAdd(vectorScale(eulerToVector("0 0 "@360/1000*$FBStep),50),"0 0 1.45");
	%rot = eulerToAxis("0 0 "@(-360/1000*$FBStep)-90);
	SSFlatBedDet.setTransform(%pos SPC %rot);
	SSFlatBedCOL.setTransform(%pos SPC %rot);
	%TFB = TriggerFlatBed;
	%TFB.pos = %TFB.getPosition();
	%TFB.setTransform(vectorAdd(%pos,"0 0 -0.45") SPC %rot);
	%TFB.vel = vectorScale(vectorAdd(vectorScale(%TFB.pos,-1),%TFB.getPosition()),31.25/2);

	//%TFB.vel = vectorScale(%TFB.vel,4);
	%i=0;
	while(isObject(%obj = %TFB.getObject(%i)))
	{
		if(%obj.getType()&$TypeMasks::PlayerObjectType||%obj.getType()&$TypeMasks::VehicleObjectType)
		{
			%walkvec = vectorAdd(%obj.getPosition(),vectorScale(%TFB.pos[%obj],-1));
			%walklen = vectorLen(%walkvec);
			%walkangle = vectorToEuler(%walkvec);
			%walkvecAdj = vectorScale(EulerToVector(vectorAdd(%walkangle,"0 0 -0.36")),%walklen);
			//%adjustedAA = setWord(%adjustedAA,3,mRadtoDeg(getWord(%adjustedAA,3)));

			%rotAngle = axisToEuler(getWords(%obj.getTransform(),3,6));
			%rotAngleAdj = EulerToAxis(vectorAdd(%rotAngle,"0 0 -0.36"));
			//if(isObject(%client = %obj.client))
			//	%client.centerPrint(%walklen@"\n"@%walkvec@"\n"@%walkvecAdj@"\n"@%rotAngleAdj,1);

			%walkPointAdj = vectorAdd(%TFB.pos[%obj],%walkvecAdj);

			%groundAdj = vectorAdd(%TFB.getPosition(),vectorScale(%TFB.pos,-1));
			%groundToObjVec = vectorAdd(%walkPointAdj,vectorScale(%TFB.pos,-1));
			%gTORot = vectorToEuler(%groundToObjVec);
			%gTOAdj = vectorScale(EulerToVector(vectorAdd(%gTORot,"0 0 0.36")),vectorLen(%groundToObjVec));
			//if(isObject(%client = %obj.client))
			//	%client.centerPrint(%walklen@"\n"@%groundToObjVec@"\n"@%gTORot@"\n"@%gTOAdj@"\n"@vectorLen(%groundToObjVec),1);
			%nextPosition = vectorAdd(vectorAdd(%TFB.pos,%gTOAdj),%groundAdj);

			//find out if where we are on the object's local xyz
			%relativePos = vectorAdd(%nextPosition,vectorScale(%TFB.getPosition(),-1));
			%vy = %TFB.getForwardVector();
			%vz = %TFB.getUpVector();
			%vx = vectorCross(%vy,%vz);
			%footprint = mAbs(getWord(%obj.getObjectBox(),0)/3.5);//THIS IS WRONG!  THIS OBJECT DOES NOT ALIGN WITH THE LOCAL GRID.  SETTING IT TO 3.5 IS TEMPORARY, BUT WE SHOULD REALLY BE USING 4, AND TAKING INTO ACCOUNT THAT OUR PLAYER BOX IS ESSENTIALLY A BOX THAT IS ROTATING AGAINST OUR LOCAL GRID.
			//%obj.client.centerPrint(%relativePos@"\n"@vectorDot(%vx,%relativePos)@" ? "@getWord(%TFB.scale,0)/2@"\n"@vectorDot(%vy,%relativePos)@" ? "@getWord(%TFB.scale,1)/2@"\n"@vectorDot(%vz,%relativePos),1);
			if(mAbs(vectorDot(%vx,%relativePos))<getWord(%TFB.scale,0)/2+%footprint&&mAbs(vectorDot(%vy,%relativePos))<getWord(%TFB.scale,1)/2+%footprint)
			{
				%obj.setTransform(%nextPosition SPC %rotAngleAdj);
				if(%TFB.pos[%obj]$="")
				{
					%sim = vectorScale(vectorAdd(vectorScale(%TFB.vel,-1),%obj.getVelocity()),1);//,-1);
					%obj.setVelocity(%sim);//negative of the similarities of our velocities
				}
				%TFB.pos[%obj] = %obj.getPosition();
			}
			else
			{
				if(%TFB.pos[%obj]!$="")
				{
					if(%obj.getType()&$TypeMasks::PlayerObjectType)
						%obj.addVelocity(%trigger.vel);
					if(%obj.getType()&$TypeMasks::VehicleObjectType)
						%obj.setVelocity(vectorAdd(%obj.getVelocity(),%trigger.vel));
				}
				%TFB.pos[%obj] = "";
			}
		}
		%i++;
	}

	//Brick clearing stuff
	%frontpos = vectorAdd((vectorAdd(vectorScale(%TFB.getForwardVector(),4),%TFB.getPosition())),"0 0 2");
	%brick = containerFindFirst($TypeMasks::fxBrickObjectType,%frontpos,2,2,2);
	while(isObject(%brick))
	{
		//if(%brick.colorfxID!=3)
		//{
		//	%brick.setColorFX(3);
		//	%brick.schedule(4000,"setColorFX",0);
		//}
		//%str = %str SPC %brick;
		if(!%brick.isDead())
			%brick.killBrick();
		%brick = containerFindNext();
	}
//	if(isObject(%client = ClientGroup.getObject(0)))
//		%client.centerPrint(%str,1);

	$FBStep+=1;
	if($FBStep>=1000)
		$FBStep = 0;
}

function stepLoop()
{
	cancel($stepLoop);
	stepFlatBed();

	$stepLoop = schedule(68,SSFlatBedDet,"stepLoop");
}

datablock TriggerData(FlatBedTrigger)
{
	tickPeriodMS = 34;
};

//[  allGameScripts:    8356] TriggerData::onEnterTrigger(%this, %trigger, %obj)
//[  allGameScripts:    8360] TriggerData::onLeaveTrigger(%this, %trigger, %obj)
//[  allGameScripts:    8364] TriggerData::onTickTrigger(%this, %trigger, %obj)
function FlatBedTrigger::onEnterTrigger(%this, %trigger, %obj)
{
	if(%obj.getType()&$TypeMasks::PlayerObjectType||%obj.getType()&$TypeMasks::VehicleObjectType)
	{
		%relativePos = vectorAdd(%obj.getPosition(),vectorScale(%trigger.getPosition(),-1));
		%vy = %trigger.getForwardVector();
		%vz = %trigger.getUpVector();
		%vx = vectorCross(%vy,%vz);
		%footprint = mAbs(getWord(%obj.getObjectBox(),0)/3.5);
		if(mAbs(vectorDot(%vx,%relativePos))<getWord(%trigger.scale,0)/2+%footprint&&mAbs(vectorDot(%vy,%relativePos))<getWord(%trigger.scale,1)/2+%footprint)
		{
			%sim = vectorScale(vectorAdd(vectorScale(%trigger.vel,-1),%obj.getVelocity()),1);//,-1);
			%obj.setVelocity(%sim);//negative of the similarities of our velocities
			%trigger.pos[%obj] = %obj.getPosition();
		}
	}

	//if(isObject(%client = %obj.client))
	//{
	//	%client.chatmessage("\c6"@%obj@" Entered, velocity "@%sim);
	//}

}
function FlatBedTrigger::onLeaveTrigger(%this, %trigger, %obj)
{
	//if(isObject(%client = %obj.client))
	//	%client.chatmessage("\c6"@%obj@" Left");

	if(%trigger.pos[%obj]!$="")
	{
		if(%obj.getType()&$TypeMasks::PlayerObjectType)
			%obj.addVelocity(%trigger.vel);
		if(%obj.getType()&$TypeMasks::VehicleObjectType)
			%obj.setVelocity(vectorAdd(%obj.getVelocity(),%trigger.vel));
		%trigger.pos[%obj] = "";
	}
}

function servercmdvelcheckloop(%client)
{
	if(!isObject(%player = %client.player))
		return;

	velcheckloop(%player);
}

function velcheckloop(%player)
{
	cancel($velcheckloop);

	%vel = vectorScale(vectorAdd(vectorScale(%player.pos,-1),%player.getPosition()),31.25);
	%player.pos = %player.getPosition();
	if(isObject(%client = %player.client))
		%client.bottomPrint(%player.getVelocity()@"\n"@%vel@"\n"@TriggerFlatBed.vel,1,1);
	$velcheckloop = schedule(34,%player,"velcheckloop",%player);
}

//boodals'

function eulerToVector(%ang) {
	if(getWordCount(%ang) == 2) //Support for giving pitch and yaw, but not roll.
		%ang = getWord(%ang, 0) SPC 0 SPC getWord(%ang, 1);

	%yaw = mDegToRad(getWord(%ang, 2));
	%pitch = mDegToRad(getWord(%ang, 0));
	%x = mSin(%yaw) * mCos(%pitch) * 1;
	%y = mCos(%yaw) * mCos(%pitch);
	%z = mSin(%pitch);

	return %x SPC %y SPC %z;
}

function axisToVector(%ang) {
	return eulerToVector(axisToEuler(%ang));
}

function vectorToEuler(%vec) {
	%vec = vectorNormalize(%vec);
	%yaw   = mRadToDeg(mATan(getWord(%vec, 0), getWord(%vec, 1)));
	%pitch = mRadToDeg(mASin(getWord(%vec, 2)));
	return %pitch SPC 0 SPC %yaw;
}

function vectorToAxis(%vec) {
	return eulerToAxis(vectorToEuler(%vec));
}

//Trader's

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}

//From Complex Weapons
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler, $pi / 180);
	return getWords(MatrixCreateFromEuler(%euler), 3, 6);
}